<?php
require_once "PerLeDi.class.php";
require_once "lib/classes/Seminar.class.php";
require_once "vendor/flexi/flexi.php";

class PerLeDiPlugin extends AbstractStudIPStandardPlugin {
	
	var $template_factory;
	var $config = array();
	var $perpage = 5;
	var $perle = null;
	
	/**
	 * 
	 */
	function PerLeDiPlugin(){
		AbstractStudIPStandardPlugin::AbstractStudIPStandardPlugin();
		$this->setPluginiconname('images/icon-posting.gif');
		$this->setChangeindicatoriconname('images/icon-posting2.gif');
        $this->template_factory = new Flexi_TemplateFactory(dirname(__FILE__).'/templates/');
		$this->restoreConfig($GLOBALS['SessSemName'][1]);
		$navigation = new PluginNavigation();
		$navigation->setDisplayname($this->config['PERLE_DISPLAYNAME'] ? $this->config['PERLE_DISPLAYNAME'] : _("Persnlicher Lerndialog"));
        $navigation->addLinkParam('action', 'main');
		if ($GLOBALS['perm']->have_studip_perm('tutor', $this->getId())){
			$config_nav =& new PluginNavigation();
			$config_nav->setDisplayname(_("Anpassen"));
			$config_nav->addLinkParam('action', 'config');
			$navigation->addSubmenu($config_nav);
		}
		$this->setNavigation($navigation);
	}
	
	function initialize(){
	}
	
	function getDisplayname(){
		$this->restoreConfig();
		return $this->config['PERLE_DISPLAYNAME'] ? $this->config['PERLE_DISPLAYNAME'] : _("Persnlicher Lerndialog");
	}
	
	function isShownInOverview(){
		$this->initPerle();
		return $this->countPostings();
	}

	
	function getOverviewMessage($has_changed = false){
		$this->initPerle();
		$ret = $this->getDisplayname() . ': ' ;
		$ret .= $this->countPostings() . ' Beitrge';
		if($has_changed){
			$ret .= ','.$this->countPostings('new_postings') . ' Neue';
		}
		return $ret;
	}

	function hasChanged($lastviewed){
		$this->initPerle();
		$this->perle->getMembersPostings($lastviewed);
		return $this->countPostings('new_postings');
	}
	
	function countPostings($count_what = 'postings'){
		$count = 0;
		if($GLOBALS['perm']->have_studip_perm('tutor', $this->getId())){
			foreach($this->perle->members as $member) $count += $member[$count_what];
		} else {
			$count = $this->perle->members[$GLOBALS['user']->id][$count_what];
		}
		return $count;
	}
	
	function actionShow(){
		$this->initPerle();
		if($_REQUEST['action'] == 'config'){
			return $this->displayConfigPage();
		} else {
			return $this->displayMainPage();
		}
	}
	
	function displayConfigPage(){
        $msg = array();
		if(isset($_REQUEST['save_x'])){
			$name = stripslashes(trim($_REQUEST['perle_displayname']));
			$text = stripslashes(trim($_REQUEST['perle_infotext']));
			$this->config['PERLE_DISPLAYNAME'] = $name;
			$this->config['PERLE_INFOTEXT'] = $text;
			if($this->storeConfig()){
					$msg[] = array('msg', _("Die Einstellungen wurden gespeichert."));
				}
			
		}

		$template = $this->template_factory->open('config');
		$template->set_attribute('msg', $msg);
        $template->set_attribute('plugin', $this);
		$template->set_attribute('config', $this->config);
        echo $template->render();
	}
	
	function displayMainPage(){
		$msg = array();
		$this->initPerle();
		$this->perle->getMembersPostings(object_get_visit($this->getId(),'sem'));
		if($GLOBALS['perm']->have_studip_perm('tutor', $this->getId())){
			$show_user_chooser = true;
			if(isset($_REQUEST['choose_user_x']) || isset($_REQUEST['send_posting_x'])){
				$this->perle->user_id = $_REQUEST['perle_choose_user'];
			}
			if(isset($_REQUEST['assert_kill_all_x'])){
				$msg[] = array('info',
				'Wollen Sie wirklich alle Beitrge lschen?
				<br>
				<a href="'.PluginEngine::getLink($this, array('action' => 'kill_all')).'">'
				. makeButton('ja2')
				.'</a>&nbsp;<a href="'.PluginEngine::getLink($this).'">'
				. makeButton('nein')
				. '</a>');
			}
			if($_REQUEST['action'] == 'kill_all'){
				if($count = $this->perle->deleteAllPostings()){
					$msg[] = array('msg', sprintf(_("Es wurden alle %s Beitrge gelscht."), $count));
					$this->perle->getMembersPostings();
				}
			}
		} else {
			$this->perle->user_id = $GLOBALS['user']->id;
			$show_user_chooser = false;
		}
		if(isset($_REQUEST['send_posting_x'])){
			if($_REQUEST['perle_id']){
				$posting = $this->perle->getPosting($_REQUEST['perle_id']);
				if($posting['autor_id'] == $GLOBALS['user']->id || $GLOBALS['perm']->have_perm('root')){
					if($this->perle->updatePosting($_REQUEST['perle_id'], stripslashes(trim($_REQUEST['new_posting'])))){
						$msg[] = array('msg',"Ihr Beitrag wurde gendert.");
						$this->perle->getMembersPostings();
					}
				}
			} else {
				if($this->perle->addPosting(stripslashes(trim($_REQUEST['new_posting'])))){
					$msg[] = array('msg',"Ihr Beitrag wurde hinzugefgt.");
					$this->perle->getMembersPostings();
				}
			}
		}
		if($_REQUEST['action'] == 'quote'){
			$posting = $this->perle->getPosting($_REQUEST['perle_id']);
			if($posting['content'] && ($posting['autor_id'] == $GLOBALS['user']->id || $GLOBALS['perm']->have_perm('root'))){
				$quoted_posting = quotes_encode($posting['content'], $posting['fullname']);
			}
		}
		if($_REQUEST['action'] == 'edit'){
			$posting = $this->perle->getPosting($_REQUEST['perle_id']);
			if($posting['content'] && ($posting['autor_id'] == $GLOBALS['user']->id || $GLOBALS['perm']->have_perm('root'))){
				$quoted_posting = $posting['content'];
			}
		}
		if($_REQUEST['action'] == 'kill'){
			$posting = $this->perle->getPosting($_REQUEST['perle_id']);
			if($posting['autor_id'] == $GLOBALS['user']->id || $GLOBALS['perm']->have_perm('root')){
				if($this->perle->killPosting($posting['perle_id'])){
					$msg[] = array('msg',"Ihr Beitrag wurde gelscht.");
					$this->perle->getMembersPostings();
				}
			}
		}
		if(!$this->perle->members[$this->perle->user_id]) $this->perle->user_id = key($this->perle->members);
		if(!count($this->perle->members)){
			$msg[] = array('info', _("In dieser Veranstaltung sind noch keine Teilnehmer eingetragen!."));
		}
		$template = $this->template_factory->open('main');
		$template->set_attribute('msg', $msg);
        $template->set_attribute('plugin', $this);
		$template->set_attribute('perle', $this->perle);
		$template->set_attribute('quoted_posting', $quoted_posting);
		$template->set_attribute('edit_perle_id', ($_REQUEST['action'] == 'edit' ? $_REQUEST['perle_id'] : ''));
		$template->set_attribute('show_user_chooser', $show_user_chooser);
		echo $template->render();
	}
	
	function restoreConfig($seminar_id = ''){
		$this->config = array();
		$db = new DB_Seminar();
		if($this->getId() == UNKNOWN_ID) $id = $seminar_id;
		else $id = $this->getId();
		$db->queryf("SELECT * FROM user_config WHERE user_id='%s' AND field LIKE 'PERLE%%'", $id);
		while($db->next_record()){
			$this->config[$db->f('field')] = $db->f('value');
		}
		return count($this->config);
	}
	
	function storeConfig(){
		$ret = 0;
		$new_config = $this->config;
		$this->restoreConfig();
		$db = new DB_Seminar();
		foreach($new_config as $field => $value){
			if($this->config[$field] != $value){
				$db->queryf("REPLACE INTO user_config (user_id, userconfig_id, field, value, chdate) VALUES ('%s','%s','%s','%s', UNIX_TIMESTAMP())",
							$this->getId(), md5($field), $field, mysql_escape_string($value));
				++$ret;
			}
		}
		$this->restoreConfig();
		return $ret;
	}
	
	function getNavi($maxpostings) {
		$i = 1;
		$ipage = $_REQUEST['currentpage'] ? abs($_REQUEST['currentpage'])  : 1;
		$maxpages = (int)($maxpostings / $this->perpage) +1;
		if ($ipage != 1){
			$navi .= "<a href=\"".PluginEngine::getLink($this)."&currentpage=".($ipage-1)."\"><font size=-1>" . _("zurck") . "</a> | </font>";
		} else {
			$navi .= "<font size=\"-1\">Seite: </font>";
		}
		while ($i <= $maxpages) {
			if ($i == 1 || $i+2 == $ipage || $i+1 == $ipage || $i == $ipage || $i-1 == $ipage || $i-2 == $ipage || $i == $maxpages) {
				if ($space == 1) {
					$navi .= "<font size=-1>... | </font>";
					$space = 0;
				}
				if ($i != $ipage) $navi .= "<a href=\"".PluginEngine::getLink($this)."&currentpage=".$i."\"><font size=-1>".$i."</a></font>";
				else $navi .= "<font size=\"-1\"><b>".$i."</b></font>";
				if ($maxpages != 1) $navi .= "<font size=\"-1\"> | </font>";
			} else {
				$space = 1;
			}
			$i++;
		}
		if ($ipage != $maxpages) $navi .= "<a href=\"".PluginEngine::getLink($this)."&currentpage=".($ipage+1)."\"><font size=-1> " . _("weiter") . "</a></font>";
		return $navi;
	}
	
	function initPerle(){
		if(is_null($this->perle)){
			$this->perle =& new PerLeDi($this->getId());
			$this->perle->getMembersPostings();
		}
	}
}
?>